package oop10;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * FlowLayout manager lines the components horizontally until
 * there is no room and then starts a new row of components.
 */
public class Layout01FlowLayout {
	public static void main(String[] args)	{  
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				Frame01 frame = new Frame01();
				frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				frame.setVisible(true);
			}
		});
	}
}

class Frame01 extends JFrame
{
	private static final long serialVersionUID = 1L;
	public static final int DEFAULT_WIDTH = 300;
	public static final int DEFAULT_HEIGHT = 200;  

	public Frame01()
	{
		setTitle("ButtonTest");
		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		FlowLayoutPanel panel = new FlowLayoutPanel();
		add(panel);
	}
}

class FlowLayoutPanel extends JPanel
{  
	private static final long serialVersionUID = 1L;
	public FlowLayoutPanel()
	{  
		//Bileenleri eklemeden nce setLayout kullan.
		setLayout(new FlowLayout(FlowLayout.CENTER));
		/*Alternatif deerler:
		 * FlowLayout.LEFT 
		 * FlowLayout.CENTER (default), 
		 * FlowLayout.RIGHT 
		 *Alternatif kurucu:
		 * FlowLayout(int align, int hgap, int vgap)
		 * align: nceki deerler.
		 * hgap: bileenler aras yatay aralk.
		 * vgap: dikey aralk.
		 * Negatif aralklar rten bileenlere sebep olur. 
		 * */

		JButton yellowButton = new JButton("Yellow");
		JButton blueButton = new JButton("Blue");
		JButton redButton = new JButton("Red");

		add(yellowButton);
		add(blueButton);
		add(redButton);
		
		ColorAction yellowAction = new ColorAction(Color.YELLOW);
		ColorAction blueAction = new ColorAction(Color.BLUE);
		ColorAction redAction = new ColorAction(Color.RED);
		
		yellowButton.addActionListener(yellowAction);
		blueButton.addActionListener(blueAction);
		redButton.addActionListener(redAction);
	}
	
	private class ColorAction implements ActionListener
	{  
		private Color backgroundColor;
		public ColorAction(Color c) {  
			backgroundColor = c;
		}
		
		public void actionPerformed(ActionEvent event) {  
			setBackground(backgroundColor);
		}
	}
}

