package oop10;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * NORTH, SOUTH	: Ykseklik sabit, genilik pencere genilii.
 * EAST	, WEST	: Ykseklik pencere ykseklii, genilik sabit.
 * CENTER		: Dier konumlardan geri kalan alann tm. 
 */
public class Layout02BorderLayout extends JFrame {
	private static final long serialVersionUID = 1L;
	public static final int DEFAULT_WIDTH = 300;
	public static final int DEFAULT_HEIGHT = 200;  

	public Layout02BorderLayout()
	{
		setTitle("ButtonTest");
		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		BorderLayoutPanel panel = new BorderLayoutPanel();
		add(panel);
	}
	
	public static void main(String[] args)	{  
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				Layout02BorderLayout frame = new Layout02BorderLayout();
				frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				frame.setVisible(true);
			}
		});
	}

	class BorderLayoutPanel extends JPanel
	{  
		private static final long serialVersionUID = 1L;
		public BorderLayoutPanel()
		{
			setLayout(new BorderLayout());
			//veya BorderLayout( int hgap, int vgap )
			
			JButton yellowButton = new JButton("Yellow");
			JButton blueButton = new JButton("Blue");
			JButton redButton = new JButton("Red");
			JButton greenButton = new JButton("Green");
			JButton whiteButton = new JButton("White");
			
			/* Renk deiiklii belli olsun istiyorsan
			 * CENTER konumdakini remarkla. 
			 * Dier konumlarda eleman 
			 * olmazsa o ksm hi gsterilmiyor. */
			add(yellowButton, BorderLayout.WEST);
			add(blueButton, BorderLayout.CENTER);
			add(redButton, BorderLayout.EAST);
			add(greenButton, BorderLayout.NORTH);
			add(whiteButton, BorderLayout.SOUTH);
			
			ColorAction yellowAction = new ColorAction(Color.YELLOW);
			ColorAction blueAction = new ColorAction(Color.BLUE);
			ColorAction redAction = new ColorAction(Color.RED);
			ColorAction greenAction = new ColorAction(Color.GREEN);
			ColorAction whiteAction = new ColorAction(Color.WHITE);
			
			yellowButton.addActionListener(yellowAction);
			blueButton.addActionListener(blueAction);
			redButton.addActionListener(redAction);
			greenButton.addActionListener(greenAction);
			whiteButton.addActionListener(whiteAction);
		}
		
		private class ColorAction implements ActionListener
		{  
			private Color backgroundColor;
			public ColorAction(Color c) {  
				backgroundColor = c;
			}
			
			public void actionPerformed(ActionEvent event) {  
				setBackground(backgroundColor);
				setTitle("ButtonTest: (" + backgroundColor.getRed()
						+ "," + backgroundColor.getGreen() 
						+ "," + backgroundColor.getBlue() + ")"	);
			}
		}
	}
}
