package oop10;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Alan satr ve stunlara bler. Bileenler eit boyutta olur,
 * pencere bydke o oranda bileenler de byr.
 * Ortada biryerleri bo brakmak istiyorsan oraya bo bir panel
 * eklemelisin. 
 */
public class Layout03GridLayout {
	public static void main(String[] args)	{  
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				Frame03 frame = new Frame03();
				frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				frame.setVisible(true);
			}
		});
	}
}

class Frame03 extends JFrame
{
	private static final long serialVersionUID = 1L;
	public static final int DEFAULT_WIDTH = 300;
	public static final int DEFAULT_HEIGHT = 200;  

	public Frame03()
	{
		setTitle("ButtonTest");
		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		GridLayoutPanel panel = new GridLayoutPanel();
		add(panel);

		/* Pencere boyutunu iindeki bileenlerin tercih
		 * edilen veya varsaylan boyutlarn dikkate
		 * alacak ekilde, layout manager kurallarna da
		 * dikkat ederek yeniden boyutlandrr.
		 * */
		pack();
	}
}

class GridLayoutPanel extends JPanel
{  
	private static final long serialVersionUID = 1L;
	public GridLayoutPanel()
	{
		setLayout(new GridLayout(3,2));
		/* GridLayout( int satir, int sutun );
		 * GridLayout( int row, int col, int hgap, int vgap );
		 * */
		
		JButton yellowButton = new JButton("Yellow");
		JButton blueButton = new JButton("Blue");
		JButton redButton = new JButton("Red");
		JButton greenButton = new JButton("Green");
		JButton whiteButton = new JButton("White");

		add(yellowButton);
		add(blueButton);
		add(redButton);
		add(greenButton);
		add(whiteButton);

		ColorAction yellowAction = new ColorAction(Color.YELLOW);
		ColorAction blueAction = new ColorAction(Color.BLUE);
		ColorAction redAction = new ColorAction(Color.RED);
		ColorAction greenAction = new ColorAction(Color.GREEN);
		ColorAction whiteAction = new ColorAction(Color.WHITE);
		
		yellowButton.addActionListener(yellowAction);
		blueButton.addActionListener(blueAction);
		redButton.addActionListener(redAction);
		greenButton.addActionListener(greenAction);
		whiteButton.addActionListener(whiteAction);
	}
	
	private class ColorAction implements ActionListener
	{  
		private Color backgroundColor;
		public ColorAction(Color c) {  
			backgroundColor = c;
		}
		
		public void actionPerformed(ActionEvent event) {  
			setBackground(backgroundColor);
		}
	}
}
