package oop11;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class UIElements02_TextArea extends JFrame {
	private static final long serialVersionUID = 1L;
	public static final int DEFAULT_WIDTH = 400;
	public static final int DEFAULT_HEIGHT = 200;  
	private JTextArea textArea;
	private JScrollPane scrollPane;
	private JPanel buttonPanel;
	private JButton wrapButton, wrapModeButton;

	public static void main(String[] args) {
	      EventQueue.invokeLater(new Runnable() {
	          public void run() {
	        	  UIElements02_TextArea frame = new UIElements02_TextArea();
	             frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	             frame.setVisible(true);
	          }
	       });
	}

	public UIElements02_TextArea() {
		setTitle("TextArea Test");
		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); 
		setLocation(screenSize.width/10,screenSize.height/10);
		buttonPanel = new JPanel();
		
		// add button to append text into the text area
		JButton insertButton = new JButton("Insert");
		buttonPanel.add(insertButton);
		insertButton.addActionListener(new
			ActionListener()
			{
				public void actionPerformed(ActionEvent event)
				{
					textArea.append("Bu yourdu sarmsaklasak da m saklasak," +
							" sarmsaklamasak da m saklasak? ");
				}
			});
		
		// add button to turn line wrapping on and off
		wrapButton = new JButton("Wrap");
		buttonPanel.add(wrapButton);
		wrapButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {  
					boolean wrap = !textArea.getLineWrap();
					/* Szck kaydrmay aar veya kapatr.*/
					textArea.setLineWrap(wrap);
					scrollPane.revalidate();
					wrapButton.setText(wrap ? "No Wrap" : "Wrap");
				}
			});
		
		// add button to alter line wrapping style
		wrapModeButton = new JButton("Wrap by words");
		buttonPanel.add(wrapModeButton);
		wrapModeButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event)
				{  
					boolean wrap = !textArea.getWrapStyleWord();
					/* Kaydrma iin kelime snrlarnn m (true)
					 * yoksa pencere snrlarnn m (false)
					 * kullanlacan belirler.*/
					textArea.setWrapStyleWord(wrap);
					scrollPane.revalidate();
					wrapModeButton.setText(!wrap ? "Wrap by words" 
							: "Wrap by characters");
				}
			});
		add(buttonPanel, BorderLayout.SOUTH);
		
		// add a text area with scroll bars:
		
		textArea = new JTextArea("Bu deneme mesajdr.", 8, 40);
		/* javax.swing.JTextArea
		 * JTextArea( int rows, int cols )
		 * JTextArea( String text, int rows, int cols )
		 * 	text: lk olarak gzkecek metin.
		 * 	rows: tercih edilen satr says. 
		 * 	cols: tercih edilen stun says. */
		
		scrollPane = new JScrollPane(textArea);
		/* javax.swing.JScrollPane
		 * Bir bileene kaydrma ubuu eklemek iin
		 * o bileeni bu ekilde JScrollPane iine eklersin. */

		/* inde bileen barndran kaydrma panelini de
		 * eklemeyi unutma.	*/
		add(scrollPane, BorderLayout.CENTER);
		
		/* JTextComponent metodlar kaltmla mevcut.
		 * \n gibi karakterlerde sorun yok. */
		textArea.setText(textArea.getText()+"\nzel\tkarakterler\tdenemesi!\n");
		
	}
	
}
