package oop11;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class UIElements03_CheckBox extends JFrame {
	private static final long serialVersionUID = 1L;
	public static final int DEFAULT_WIDTH = 400;
	public static final int DEFAULT_HEIGHT = 200;  
	private JLabel label;
	private JCheckBox bold;
	private JCheckBox italic;        
	private static final int FONTSIZE = 12;


	public static void main(String[] args) {
	      EventQueue.invokeLater(new Runnable() {
	          public void run() {
	        	  UIElements03_CheckBox frame = new UIElements03_CheckBox();
	             frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	             frame.setVisible(true);
	          }
	       });
	}

	public UIElements03_CheckBox() {
		setTitle("CheckBoxTest");
		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); 
		setLocation(screenSize.width/10,screenSize.height/10);
		
		label = new JLabel("The quick brown fox jumps over the lazy dog.");
		label.setFont(new Font("Serif", Font.PLAIN, FONTSIZE));
		add(label, BorderLayout.CENTER);
		
		// this listener sets the font attribute of
		// the label to the check box state
		ActionListener listener = new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				int mode = 0;
				if (bold.isSelected()) mode += Font.BOLD; 
				if (italic.isSelected()) mode += Font.ITALIC;
				label.setFont(new Font("Serif", mode, FONTSIZE));
			}
		};
		

		/* javax.swing.JCheckBox, TextField aksine retecine
		 * yazlan etiketi ile birlikte geliyor. 
		 * JCheckBox'a da ActionListener balanabilir. */
		bold = new JCheckBox("Bold");    
		bold.addActionListener(listener);
		
		JPanel buttonPanel = new JPanel();
		buttonPanel.add(bold);
		
		italic = new JCheckBox("Italic");    
		italic.addActionListener(listener);
		buttonPanel.add(italic);
		
		add(buttonPanel, BorderLayout.SOUTH);
	}
	
}
