package oop11;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

 // Her dmeye ayr olay dinleyicisi atayan bir zm.
public class UIElements04_RadioButton_Alt1 extends JFrame {
	private static final long serialVersionUID = 1L;
	public static final int DEFAULT_WIDTH = 800;
	public static final int DEFAULT_HEIGHT = 200;  
	private JPanel buttonPanel;
	private ButtonGroup group;
	private JLabel label;
	private static final int DEFAULT_SIZE = 12;


	public static void main(String[] args) {
	      EventQueue.invokeLater(new Runnable() {
	          public void run() {
	        	  UIElements04_RadioButton_Alt1 frame = new UIElements04_RadioButton_Alt1();
	             frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	             frame.setVisible(true);
	          }
	       });
	}

	public UIElements04_RadioButton_Alt1() {
		setTitle("RadioButtonTest");
		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); 
		setLocation(screenSize.width/10,screenSize.height/10);
		
		label = new JLabel("The quick brown fox jumps over the lazy dog.");
		label.setFont(new Font("Serif", Font.PLAIN, DEFAULT_SIZE));
		add(label, BorderLayout.CENTER);
		
		// add the radio buttons 
		
		buttonPanel = new JPanel();
		
		/* Bir grup dmeden hangisinin seili olacan
		 * javax.swing.ButtonGroup ayarlar. indeki
		 * dmelerden biri seilince gruptaki dierini
		 * boaltr.
		 * Dmeler hem ButtonGroup iine hem de 
		 * gzkecekleri panele ayr ayr atanmaldrlar.
		 * */
		group = new ButtonGroup();
		
		/* Kendi metodumuz olan addRadioButton  ana i
		 * yapacak: Dmeyi gruba ekleme, dmeyi panele
		 * ekleme ve dmeye ActionListener atama.
		 * */
		addRadioButton("Small", 8);
		addRadioButton("Medium", 12);
		addRadioButton("Large", 18);
		addRadioButton("Extra large", 36);
		
		add(buttonPanel, BorderLayout.SOUTH);

	}
	
	/**
	 Adds a radio button that sets the font size of the 
	 sample text.
	 @param name the string to appear on the button 
	 @param size the font size that this button sets
	 */
	public void addRadioButton(String name, final int size)	{
		boolean selected = size == DEFAULT_SIZE;

		/* javax.swing.JRadioButton da retecine
		 * yazlan etiketi ile birlikte geliyor.
		 * JRadioButton(String name, boolean isSelected) 
		 * */
		JRadioButton button = new JRadioButton(name, selected);
		
		/* JRadioButton, grubuna ve paneline ayr ayr
		 * eklenmelidir. */ 
		group.add(button);
		buttonPanel.add(button);
		button.setActionCommand(name);
		
		// this listener sets the label font size
		ActionListener listener = new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				// size refers to the final parameter of the addRadioButton method
				label.setFont(new Font("Serif", Font.PLAIN, size));
			}
		}; 
		button.addActionListener(listener);
	}

}
