package oop11;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Burada tm dmelere tek bir ActionListener rnei atayacaz. 
 * Hangi dmenin basldn tetiklenen olaydan renip 
 * seilen deeri o dmenin eylem komutundan reneceiz.
 */
public class UIElements04_RadioButton_Alt2 extends JFrame {
	private static final long serialVersionUID = 1L;
	public static final int DEFAULT_WIDTH = 800;
	public static final int DEFAULT_HEIGHT = 200;  
	private JPanel buttonPanel;
	private ButtonGroup group;
	private JLabel label;
	private static final int DEFAULT_SIZE = 12;
	private MyRadioButtonListener listener;
	
	@SuppressWarnings("unused")
	private MyRadioButton RBsmall, RBmed, RBlarge, RBxlarge;


	public static void main(String[] args) {
	      EventQueue.invokeLater(new Runnable() {
	          public void run() {
	        	  UIElements04_RadioButton_Alt2 frame = new UIElements04_RadioButton_Alt2();
	             frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	             frame.setVisible(true);
	          }
	       });
	}

	public UIElements04_RadioButton_Alt2() {
		setTitle("RadioButtonTestV2");
		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); 
		setLocation(screenSize.width/10,screenSize.height/10);
		
		label = new JLabel("The quick brown fox jumps over the lazy dog.");
		label.setFont(new Font("Serif", Font.PLAIN, DEFAULT_SIZE));
		add(label, BorderLayout.CENTER);
		
		// add the radio buttons 
		buttonPanel = new JPanel();
		group = new ButtonGroup();
		listener = new MyRadioButtonListener();

		RBsmall = new MyRadioButton("Small", 8);
		RBmed = new MyRadioButton("Medium", 12);
		RBlarge = new MyRadioButton("Large", 18);
		RBxlarge = new MyRadioButton("Extra large", 36);
		
		add(buttonPanel, BorderLayout.SOUTH);
	}
	
	
	/**
	 *  snf yapmasaydk size ve DEFAULT_SIZE bilgilerini
	 * kurucuya parametre vermeliydik. */
	private class MyRadioButton extends JRadioButton {
		private static final long serialVersionUID = 1L;
		
		public MyRadioButton( String name, int size ) {
			super(name, size == DEFAULT_SIZE);
			group.add(this);
			buttonPanel.add(this);
			addActionListener(listener);

			/* setActionCommand mutlaka altrlmal
			 * nk radyo dmesinin modelinde eylem
			 * komutu null'dr. Halbuki JButton'da eylem
			 * komutu dmenin etiketi ile aynyd.
			 * */
			setActionCommand(String.valueOf(size));
		}
	}
	
	private class MyRadioButtonListener implements ActionListener {
		public void actionPerformed(ActionEvent event)
		{
			Object source = event.getSource();
			/* (JRadioButton)source).getActionCommand() ile
			 * komut alnyor. Gerisi String->int yapmak ve
			 * font boyutunu atamaktr.
			 * */
			label.setFont(new Font("Serif", Font.PLAIN, 
					Integer.valueOf(((JRadioButton)source).getActionCommand())));
		}
	}
}
