package oop11;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class UIElements05_ComboBox_Alt1 extends JFrame {
	private static final long serialVersionUID = 1L;
	public static final int DEFAULT_WIDTH = 400;
	public static final int DEFAULT_HEIGHT = 200;  
	private JComboBox<String> faceCombo;
	private JLabel label;
	private static final int DEFAULT_SIZE = 12;

	public static void main(String[] args) {
	      EventQueue.invokeLater(new Runnable() {
	          public void run() {
	        	  UIElements05_ComboBox_Alt1 frame = new UIElements05_ComboBox_Alt1();
	             frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	             frame.setVisible(true);
	          }
	       });
	}

	public UIElements05_ComboBox_Alt1() {
		setTitle("ComboBoxTest");
		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); 
		setLocation(screenSize.width/10,screenSize.height/10);
		
		label = new JLabel("The quick brown fox jumps over the lazy dog.");
		label.setFont(new Font("Serif", Font.PLAIN, DEFAULT_SIZE));
		add(label, BorderLayout.CENTER);
		
		// make a combo box and add face names
		faceCombo = new JComboBox<String>();
		/* Alternative constructors:
		 * JComboBox(E[] items)
		 * JComboBox(Vector<E> items) */

		/* Let this JComboBox to be editable. */
		faceCombo.setEditable(true);
		/* Add an item to the end of the list.
		 * Use insertItemAt(<E> item, int index) for insertion
		 * index=0 means adding to the top.
		 * You can add/remove items even at runtime. 
		 * Use JComboBox.removeItem(<E> item) or
		 * JComboBox.removeItemAt(int index) for removal. */
		faceCombo.addItem("Serif");
		faceCombo.addItem("SansSerif");
		faceCombo.addItem("Monospaced");
		faceCombo.addItem("Dialog");
		
		/* the combo box listener changes the label font 
		 * to the selected face name.		 */
		faceCombo.addActionListener(new	ActionListener() {
			public void actionPerformed(ActionEvent event) {
				label.setFont(new Font(
						faceCombo.getItemAt(faceCombo.getSelectedIndex()), 
						Font.PLAIN, DEFAULT_SIZE));
			}
		});
		
		JPanel comboPanel = new JPanel();
		comboPanel.add(faceCombo);
		add(comboPanel, BorderLayout.SOUTH);
	}
	
}
