package oop11;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class UIElements06_Menu extends JFrame {
	private static final long serialVersionUID = 1L;
	public static final int DEFAULT_WIDTH = 400;
	public static final int DEFAULT_HEIGHT = 200;  

	public static void main(String[] args) {
	      EventQueue.invokeLater(new Runnable() {
	          public void run() {
	        	 UIElements06_Menu frame = new UIElements06_Menu();
	             frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	             frame.setVisible(true);
	          }
	       });
	}

	public UIElements06_Menu() {
		setTitle("MenuTest");
		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); 
		setLocation(screenSize.width/10,screenSize.height/10);

		/* Adm 1: Bir javax.swing.JMenuBar oluturup
		 * bunu Frame'e ata. */
		JMenuBar menuBar = new JMenuBar();
		this.setJMenuBar(menuBar);
		
		/* Adm 2: Her men iin bir javax.swing.JMenu
		 * nesnesi olutur. */
		JMenu fileMenu = new JMenu("File");
		JMenu editMenu = new JMenu("Edit");
		
		/* Adm 3: st dzey menleri JMenuBar'a ekle. */
		menuBar.add(fileMenu);
		menuBar.add(editMenu);
		
		/* Adm 4: st dzey menlere men seenekleri 
		 * ekle. javax.swing.JMenuItem. */
		JMenuItem newItem = new JMenuItem("New");
		JMenuItem openItem = new JMenuItem("Open");
		fileMenu.add(newItem);
		fileMenu.add(openItem);

		/* Adm 5: Ayra da ekleyebilirsin. */
		fileMenu.addSeparator();
		
		/* Adm 6: Alt menler de ekleyebilirsin. */
		JMenu optionsMenu = new JMenu("Options");
		fileMenu.add(optionsMenu);
		
		JMenuItem readOnlyItem = new JMenuItem("Read Only");
		optionsMenu.add(readOnlyItem);
		fileMenu.addSeparator();
		
		/* Adm 7: Gerekli eylemleri tanmla. Burada anonim i
		 * snf olarak tanmland. Eylemin adaptr snf olan 
		 * javax.swing.AbstractAction' hatrla. Bu eylem sonra
		 * men seenei olaca iin kurucusuna etiket verdik */
		Action exitAction = new AbstractAction("Exit") {
			private static final long serialVersionUID = 1L;
			public void actionPerformed(ActionEvent event) {
				System.exit(0);
			}
		};

		/* Adm 8: Eylemleri ata. 
		 * Alternatif 8a: Eylemden hemen men seenei yapmak */
		fileMenu.add(exitAction);

		/* Adm 8: Eylemleri ata. 
		 * Alternatif 8b: Mevcut men seeneine eylem atamak */
		JMenuItem testItem = new JMenuItem("Test");
		testItem.addActionListener(new TestAction01("Test"));
		editMenu.add(testItem);

		/* File mensnn eylemlerini de atayalm */
		newItem.addActionListener( new TestAction01("New") );
		openItem.addActionListener( new TestAction01("Open") );
		readOnlyItem.addActionListener( new TestAction01("Read Only") );
	}
}

class TestAction01 extends AbstractAction {  
	private static final long serialVersionUID = 1L;
	public TestAction01(String name) { super(name); }
	public void actionPerformed(ActionEvent event) {
		System.out.println(getValue(Action.NAME) + " selected.");
	}
}
